
float moveSpeed = GetObjectFloat( obj[ 0 ], 1 );

float spawnSpeedLow = GetObjectFloat( obj[ 0 ], 2 );
float spawnSpeedHigh = GetObjectFloat( obj[ 0 ], 3 );
if ( spawnSpeedHigh < 0 )
	{ spawnSpeedHigh = spawnSpeedLow; }

float explosionDamage = GetObjectFloat( obj[ 0 ], 4 );
float explosionKnockBack = GetObjectFloat( obj[ 0 ], 5 );

float barrelHitPoints = GetObjectFloat( obj[ 0 ], 6 );

string objectCfgID = GetObjectString( obj[ 0 ] );

/*************************************/

RequestRunScript( "spawn.c", spawnSpeedLow + rand() * ( spawnSpeedHigh - spawnSpeedLow ) );

float objectOffsetX = -72;
float objectOffsetY = 0;

int objectPostID = GetObjectFloat( obj[ 0 ], 8 );
SetObjectFloat_nt( obj[ 0 ], objectPostID + 1, 8 );

int idEnd = GetChild( obj[ 0 ], 0 );

pointToWorldSpace( objectOffsetX, objectOffsetY, GetAngleWorld( obj[ 0 ] ), GetPosX( obj[ 0 ] ), GetPosY( obj[ 0 ] ) );
float startX = fTmp[ 0 ];
float startY = fTmp[ 1 ];

pointToWorldSpace( objectOffsetX, objectOffsetY, GetAngleWorld( idEnd ), GetPosX( idEnd ), GetPosY( idEnd ) );
float endX = fTmp[ 0 ];
float endY = fTmp[ 1 ];

float diffX = endX - startX;
float diffY = endY - startY;
float length = sqrt( diffX * diffX + diffY * diffY );


if( !IsPositionWithinActiveArea ( startX, startY, length / 2.0 ) &&
    !IsPositionWithinActiveArea ( endX, endY, length / 2.0 ) ) 
{
	return;
}

int id = AddObjectRelative( objectCfgID, objectOffsetX, objectOffsetY, 0, obj[ 0 ], 0 );

string objectWorldID = "spawned_object_" + string( obj[ 0 ] ) + "_" + string( objectPostID );
SetWorldID( id, objectWorldID );

float time = length / moveSpeed;

int osc = GetObject("ObstacleScalingCreature");
barrelHitPoints = TransformByFunction(osc, "ObstacleCharacterLevelTransformationHitpoints", barrelHitPoints );
if ( barrelHitPoints != 0 )
{
	SetObjectFloat_nt( id, barrelHitPoints, 1 );
}

if ( explosionDamage != 0 )
	{ SetObjectFloat_nt( id, explosionDamage, 2 ); }
if ( explosionKnockBack != 0 )
	{ SetObjectFloat_nt( id, explosionKnockBack, 3 ); }

SetMovePath( id, 0, startX, startY, time, endX, endY );

float doorTime = pow( objectOffsetX * objectOffsetX + objectOffsetY * objectOffsetY, 0.5 ) / moveSpeed;

float timeForClose = min( max( spawnSpeedHigh, GetSize( id ) / moveSpeed ), doorTime );
float speed = 2.0 / timeForClose;

obj[ 0 ] = obj[ 0 ];
obj[ 1 ] = objectPostID;
RequestRunScript( "remove.c", time + timeForClose );

if ( objectPostID == 0 )
{
	SetAniSpeed( obj[ 0 ], speed );
	SetAniSpeed( idEnd, speed );
}

SetUseState( obj[ 0 ], 1 );
RequestRunScript( "SetUseState( obj[ 0 ], 0 );", doorTime );

obj[ 0 ] = idEnd;
RequestRunScript( "SetUseState( obj[ 0 ], 1 );", time - doorTime - timeForClose / 2 );
RequestRunScript( "SetUseState( obj[ 0 ], 0 );", time );
