float f = GetObjectFloat(obj[0],1);

float HITP = GetCfgConstant("SHIPCRATE_FRAGILE_HITP");
int osc = GetObject("ObstacleScalingCreature");
HITP = TransformByFunction(osc, "ObstacleCharacterLevelTransformationHitpoints", HITP);

if (f>=HITP) return; // so ExplosionDamagePhys() can not get called twice

f=f+GetTotalDamage();
SetObjectFloat(obj[0],f);
DebugMessage(f);

int x = GetPosX(obj[0]);
int y = GetPosY(obj[0]);

if (f>=HITP) //condition damage
{
	int id = AddObjectRelative("wo_shipcrate_fragile01_destroy", 0,0, 0, obj[0], 0);
	GetScale3D(obj[0]);
	SetScale3D(id,fTmp[0],fTmp[1],fTmp[2]);

	GetRotAxisAngle(obj[0]);
	SetRotAxisAngle(id,fTmp[0],fTmp[1],fTmp[2],fTmp[3]);
	SetObjectAni(id,0,3.3,0);
	//effect:
	AddEffect("fx_npc_robot_big_01_die_Particle_01", 0,0,0, id);
	//damage:
	//ExplosionDamagePhys(x, y, 100, 200, 100, 100, 100, -1 , 1); // this way no XP is gained!

	PlaySound("wo_obj_destroy_wood_metal_Alt01", obj[0]);

	SetLifeSpan(obj[0], 0);
	SetLifeSpan(id, 1);

	float explosionDamage = GetObjectFloat( obj[ 0 ], 3 );
	if ( explosionDamage > 0 )
	{
		float explosionKnockBack = GetObjectFloat( obj[ 0 ], 4 );
		float explosionKnockDown = GetObjectFloat( obj[ 0 ], 5 );
		float explosionSizeFull = GetObjectFloat( obj[ 0 ], 6 );
		float explosionSizeFallOff = GetObjectFloat( obj[ 0 ], 7 );
		
		//effect:
		AddEffect("fx_mc_marine_skill_active_plantc4_hit_special", GetPosX( obj[ 0 ] ), GetPosY( obj[ 0 ] ), 50);
		AddEffect("fx_mc_marine_skill_active_plantc4_hit", GetPosX( obj[ 0 ] ), GetPosY( obj[ 0 ] ), 50);
		//SetAutoAction(objID, "ac_mc_marine_skill_active_plantc4_explosion");
		PlaySound("wo_barrel01", obj[ 0 ]);
		
		ExplosionDamagePhys( GetPosX( obj[ 0 ] ), GetPosY( obj[ 0 ] ),
							 explosionDamage,
							 explosionKnockBack,
							 explosionKnockDown,
							 explosionSizeFull,
							 explosionSizeFallOff,
							 -1, 0, mc_ID );
	}

	RunScriptForArray( SplitString( GetObjectString( obj[ 0 ] ) ),
					   "if ( sTmp[ i ] != '' ) { AddObjectRelative( sTmp[ i ], 0, 0, 0, obj[ 0 ], 0 ); }" );

	DropInventory( obj[ 0 ], 0*GetSize( obj[ 0 ] ) );

	PlaySound( "Crate_Shatter", obj[ 0 ] );
	SetLifeSpan( obj[ 0 ], 0 );

}
